/*---------------------------------------------------------
Frame.c     

----------------------------------------------------------*/

#include "Frame.h"
#include "STC32G_NVIC.h"

/*---------------------------------------------------------
ȫֱ
----------------------------------------------------------*/
static volatile u8  Frame_TICK=0;

/*-----------------------------------------------------------*
ٽ
*-----------------------------------------------------------*/
u8 data _uxNesting_ = 0;
bit     _bEA_ = 0;

/*---------------------------------------------------------
ͳƹȫֱ
----------------------------------------------------------*/
#if USE_STATISTICAL
static u32  xdata   Stat_base=0;        //οֵ
static u32  xdata   Stat_counting=0;    //
static void Set_CPUUsage(void);
static void Statistical_init(void);
u16         xdata   CPUUsage=0;         //CPUʹʣǧֱȣ1һ
#endif


/*---------------------------------------------------------
ળʼ
----------------------------------------------------------*/
#define TIM0_DIV  (MAIN_Fosc/TICKS_PER_SEC>=65536UL?12:1)            //Ƶ
#define TIM0_LOAD ((MAIN_Fosc*2UL/TIM0_DIV/TICKS_PER_SEC+1UL)/2UL)   //װֵ
static void TickInit(void)
{
    AUXR = (TIM0_DIV == 1) ? AUXR|0x80 : AUXR&~0x80;
    TMOD &= 0xF0;                   //öʱģʽ
    TL0 = 65536UL-TIM0_LOAD;        //öʱʼ
    TH0 = 65536UL-TIM0_LOAD>>8;     //öʱʼֵ
    TF0 = 0;                        //TFO־
}


/*---------------------------------------------------------
ʱ0ж
----------------------------------------------------------*/
void Timer0() interrupt 1 
{
    Frame_TICK++;
    
    #if USE_Timer0IHOOK
        Timer0_Ihook();
    #endif
}

/*---------------------------------------------------------
main  ҪÿવһTICK_hook();
----------------------------------------------------------*/
void main(void)
{
    main_hook();            //ϵʼ
    
    #if USE_STATISTICAL
        Statistical_init(); //ͳƳʼ
    #endif
    
    Device_Init_hook();     //ʼƬ豸ص
    
    TickInit();                     //Timer0 ʼ
    Timer0_Priority(Priority_3);    //ȼ
    TR0=ET0=EA=1;                   //ʱ0ʼʱ
    
    Frame_TICK = 1;

    while(1){
        #if USE_Main_Polling
            Main_Polling();
        #endif
        if(Frame_TICK){                            
            Frame_TICK--;
            TICK_hook();    //ÿવһ
            #if USE_STATISTICAL
                Set_CPUUsage();
            #endif
        }else{
            #if USE_STATISTICAL
                Stat_counting++;
            #endif           
            #if (!USE_STATISTICAL) && (!USE_Main_Polling)
                _nop_();_nop_();_nop_();_nop_();
                PCON|=0X01;
                _nop_();_nop_();_nop_();_nop_();
            #endif
        }
    }
}
/*---------------------------------------------------------
תһεTaskDly()ʱһ
----------------------------------------------------------*/
void GotoTaskBreak(u16 Breakpoint)
{
    if(!Breakpoint)return;
    *((u16 idata*)(SP-1)) = Breakpoint;
}


/*---------------------------------------------------------
ϵ㲢ִеߵreturn
----------------------------------------------------------*/
void SsveTaskBreak(u16 idata* Breakpoint)
{
    *Breakpoint = *((u16 idata*)(SP-1));    //ϵ
    SP = SP-2;  //ȥʱֽջִreturnʱʵִеǵߺreturn
	
}

/*ͳع*/
#if USE_STATISTICAL
/*---------------------------------------------------------
CPUʹʣCPUUsage ÿһ
----------------------------------------------------------*/
static void Set_CPUUsage(void)
{
    static u16  st_nu=0;
    if(++st_nu>=TICKS_PER_SEC){
        if(Stat_counting>Stat_base){
            Stat_base=Stat_counting;
            CPUUsage=0;
        }else{
            CPUUsage = (Stat_base-Stat_counting)/(Stat_base/1000UL);
        }
        Stat_counting = st_nu = 0;
    }
}

/*---------------------------------------------------------------
ͳƳʼͳ1 Stat_counting ˶ٴΣStat_base
----------------------------------------------------------------*/
static void Statistical_init(void)
{
    TickInit();
    Frame_TICK = 0;
    Stat_counting=0;
    TR0=ET0=EA=1;
    while(1){
        if(Frame_TICK){
            TR0=ET0=EA=0;
            Stat_base = Stat_counting*TICKS_PER_SEC; 
            Stat_counting = 0;
            return;
        }else{
            Stat_counting++;
        }
    }
}
#endif

/*---------------------------------------------------------
* STCISP⣬ֻҪ⵽ظݵһͷ
*
*ɺҪαԱ
----------------------------------------------------------*/
#if USE_STCISP_MOMITORING
void isp_monitoring(u8 *buf, u16 len)
{
    static u8 xdata nu=0, key=0;
    while(len--){
        if(*buf==key){
            nu++;
        }else{
            nu=0;
            key=*buf;
        }
        buf++;
        if(nu>=STCISP_KEYWORDS_COUNT) IAP_CONTR=0X60;
    }
}
#endif
